""""

-----------
**Context**
-----------

The goal here is to deliver:

* short-term daily forecasts on a 14 days horizon
* mid-term weekly forecasts on a 12 weeks horizon
* mid-term monthly forecasts on a 3 months horizon

Results are sent to the IBP environment to be shared to France Waters Demand Planners.

Forecast granularities:

* predict volumes per ``FU / National / Day``
* predict volumes per ``FU / National / Week``
* predict volumes per ``Brand / Region / Week``
* predict volumes per ``FU / National / Month``
* predict volumes per ``Brand / Region / Month``

Additional feature : Promotional effects (uplifts) must be calculated for each forecast.
Those represent the percentage of volume that was generated by promotional effects.

--------------
**Data model**
--------------

.. figure:: ./../_static/data_model_france_waters.svg
  :width: 800
  :align: center

----------------
**Data Sources**
----------------

* Addresses (~ addresses/departments mapping)
* Blue Planner Customers (~ Blue Planner franchise/RFA-NFA mapping)
* Blue Planner promotion mechanics
* Blue Planner Promotions
* Cities (cities-departments mapping)
* Customers hierarchy
* Forecast Units Filters (~ active Forecast Units on which to forecast)
* Forecast Units (~ SKU/FU mapping)
* Orders (delivered and future orders)
* Products hierarchy
* Regions (~ departments/regions mapping)
* SAP-APO customers (~ SAP ship-to customers/RFA-NFA mapping)
* National sellout (from IRI)
* Unit of Measures (~ conversion table for quantities)
* National Weighted Distribution
* Days-off, bank holidays and school holidays by zones A, B, C
* Daily Weather data for specified cities

--------------------------------------
**Data Preparation Pipelines**
--------------------------------------

**Core panel preparation steps**
================================

TBC

1. Orders
---------

* Gathers data
* Filters data
* Adds volume conversion using ``UOM_MAPPING`` [1]
* Updates target column (delivered volumes)
* Integrates FU using ``SKU_FU_MAPPING`` [2]
* Updates ``orders_creation_date`` when wrong or missing
* Adds future orders features

2. Products
-----------

* Gathers data
* Formats data (``sales_organization_cod`` etc.)
* Aggregates distribution channels with the following rules:
    * ``mat_creation_dat``: minimum
    * ``mat_start_validation_dat``: minimum
    * ``mat_end_validation_dat``: maximum
    * first occurrence for all other attributes
* Filters and update expression units for weights, volumes, dimensions
* Integrates FU using ``SKU_FU_MAPPING`` [3] and aggregates to FU level with the following rules:
    * ``fu_desc``: first occurrence
    * ``mat_creation_date``: minimum
    * ``mat_start_validation_dat``: minimum
    * ``mat_end_validation_dat``: maximum
    * most frequent value for all other attributes

3. Customers
------------

* Gathers data
* Formats data (``sales_organization_cod`` codes etc.)
* Aggregates distribution channels keeping first occurrence for all attributes
* Integrate departments using ``ADDRESS_DPTMT_MAPPING`` [4]

4. Weather
----------

* Gathers data
* Corrects data, formats them and add features
* Integrate departments using ``CITY_DEPARTMENT_MAPPING`` [5]


5. Calendar
-----------

* Gathers data
* Formats data (datetime etc.)
* Integrate departments

6. Sellout
----------

* Gathers data
* Extracts and add EAN codes and dates from raw data
* Add SKU using ``UOM_MAPPING`` [6]
* Updates data level to SKU with the following calculation to generate sellout value:

``(sellout_per_ean)/(number_of_sku_per_ean)``

* Adds and aggregates to FU level using ``SKU_FU MAPPING`` [7] and summing sellout values
* Resample data to daily granularity generating a ``sellout_of_week`` value
  for each day corresponding to the sellout value of previous weekly data frame.

7. Promos
---------

* Gathers data
* Filters data
* Builds ``BUSINESS_CUSTOMERS_MAPPING`` [8]
* Integrates customers count and market shares
* Adds discount rate, threshold and tier features [10]
* Generates dates index based on promotion starting and ending dates

8. Input table generation
-------------------------
* Loads previously generated ``ORDERS``, ``PRODUCTS``, ``CUSTOMERS``, ``WEATHER``, ``CALENDAR``,
  ``SELLOUT``, ``PROMOS`` data
* Aggregates ``ORDERS`` to daily level summing target ``ordered_volumes`` and all
  ``future_ordered_volumes``, and keeping minimum for ``lead_time_week``
* Generates full indexes ``fu_cod``, ``location_cod``, ``to_dt`` indexes and merge aggregated orders
  into it, filling resulting NaN with 0 for ``ordered_volumes`` only.
* Integrates ``PRODUCTS`` [11]
* Integrates ``CUSTOMERS`` [12]
* Aggregates resulting table to required location level (national or departmental)
* Integrates ``WEATHER`` [13]
* Integrates ``HOLIDAYS`` [14]
* Integrates ``SELLOUT`` if location level is national [15]
* Integrates ``PROMO`` if location level is national [16]

**Promotion preparation pipeline**
==================================

TBC

**Building Blocks**
===================

TBC

**IBP Export**
==============

TBC

"""
